#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <errno.h>
#include <sys/stat.h>

#include "config.h"
#include "target.h"
#include "fnmanip.h"
#include "critbit.h"
#include "eprintf.h"


static strmap_t remote_dirs;

typedef struct
{
  char *name;
  int status;
} remote_dir_t;


int make_remote_dirs(char *name)
{
  char *dir;
  remote_dir_t *RD;
  size_t i,offset;

  if (!strchr(name, '/')) return 0;
  
  dir= strdup(name);
  offset= 0;
again:
  for(i=offset;name[i];i++)
    if (name[i]=='/')
    {
      dir[i]= 0;
      goto checkdir;
    }
  goto success;
checkdir:
  offset= i; 

  RD= strmap_find(&remote_dirs, dir);
  if (RD)
  {
    if (RD->status) goto fail;
    goto next;
  }

  RD= malloc(sizeof(*RD));
  RD->name= strdup(dir);
  RD->status= target_mkdir(dir);
  strmap_insert(&remote_dirs, RD->name, RD);
  if (RD->status) goto fail;

next:
  dir[offset]= '/';
  offset++;
  goto again;

fail:
  free(dir);
  return 1;

success:
  free(dir);
  return 0;
}
